# coding: utf-8

"""
    CyPerf Application API

    CyPerf REST API

    The version of the OpenAPI document: 1.0.0
    Contact: support@keysight.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cyperf.models.action_metadata import ActionMetadata
from cyperf.models.parameter import Parameter
from typing import Optional, Set, Union, GenericAlias, get_args
from typing_extensions import Self
from pydantic import Field

class AppsecAppMetadata(BaseModel):
    """
    AppsecAppMetadata
    """ # noqa: E501
    actions_metadata: Optional[List[ActionMetadata]] = Field(default=None, alias="ActionsMetadata")
    app_parameters: Optional[List[Parameter]] = Field(default=None, alias="AppParameters")
    __properties: ClassVar[List[str]] = ["ActionsMetadata", "AppParameters"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AppsecAppMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in actions_metadata (list)
        _items = []
        if self.actions_metadata:
            for _item in self.actions_metadata:
                if _item:
                    _items.append(_item.to_dict())
            _dict['ActionsMetadata'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in app_parameters (list)
        _items = []
        if self.app_parameters:
            for _item in self.app_parameters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['AppParameters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AppsecAppMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            _obj = cls.model_validate(obj)
#            _obj.api_client = client
            return _obj

        _obj = cls.model_validate({
            "ActionsMetadata": [ActionMetadata.from_dict(_item) for _item in obj["ActionsMetadata"]] if obj.get("ActionsMetadata") is not None else None,
                        "AppParameters": [Parameter.from_dict(_item) for _item in obj["AppParameters"]] if obj.get("AppParameters") is not None else None
            ,
            "links": obj.get("links")
        })
        return _obj


