# coding: utf-8

"""
    CyPerf Application API

    CyPerf REST API

    The version of the OpenAPI document: 1.0.0
    Contact: support@keysight.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cyperf.models.diagnostic_component import DiagnosticComponent
from cyperf.models.diagnostic_options import DiagnosticOptions
from typing import Optional, Set, Union, GenericAlias, get_args
from typing_extensions import Self
from pydantic import Field

class DiagnosticComponentContext(BaseModel):
    """
    DiagnosticComponentContext
    """ # noqa: E501
    component_list: List[DiagnosticComponent] = Field(description="A list of components and subcomponents.", alias="componentList")
    context: Optional[List[DiagnosticOptions]] = Field(default=None, description="Additional information about the caller or about the case where the operation was called.")
    __properties: ClassVar[List[str]] = ["componentList", "context"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DiagnosticComponentContext from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in component_list (list)
        _items = []
        if self.component_list:
            for _item in self.component_list:
                if _item:
                    _items.append(_item.to_dict())
            _dict['componentList'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in context (list)
        _items = []
        if self.context:
            for _item in self.context:
                if _item:
                    _items.append(_item.to_dict())
            _dict['context'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DiagnosticComponentContext from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            _obj = cls.model_validate(obj)
#            _obj.api_client = client
            return _obj

        _obj = cls.model_validate({
            "componentList": [DiagnosticComponent.from_dict(_item) for _item in obj["componentList"]] if obj.get("componentList") is not None else None,
                        "context": [DiagnosticOptions.from_dict(_item) for _item in obj["context"]] if obj.get("context") is not None else None
            ,
            "links": obj.get("links")
        })
        return _obj


