# coding: utf-8

"""
    CyPerf Application API

    CyPerf REST API

    The version of the OpenAPI document: 1.0.0
    Contact: support@keysight.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cyperf.models.config_metadata_config_data_value import ConfigMetadataConfigDataValue
from typing import Optional, Set, Union, GenericAlias, get_args
from typing_extensions import Self
from pydantic import Field

class OpenAPIDefinitions(BaseModel):
    """
    OpenAPIDefinitions
    """ # noqa: E501
    open_api_definitions: Optional[Dict[str, ConfigMetadataConfigDataValue]] = Field(default=None, description="The OpenAPI definitions for CyPerf data model", alias="openApiDefinitions")
    __properties: ClassVar[List[str]] = ["openApiDefinitions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OpenAPIDefinitions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in open_api_definitions (dict)
        _field_dict = {}
        if self.open_api_definitions:
            for _key in self.open_api_definitions:
                if self.open_api_definitions[_key]:
                    _field_dict[_key] = self.open_api_definitions[_key].to_dict()
            _dict['openApiDefinitions'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OpenAPIDefinitions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            _obj = cls.model_validate(obj)
#            _obj.api_client = client
            return _obj

        _obj = cls.model_validate({
            "openApiDefinitions": dict(
                (_k, ConfigMetadataConfigDataValue.from_dict(_v))
                for _k, _v in obj["openApiDefinitions"].items()
            )
            if obj.get("openApiDefinitions") is not None
            else None
            ,
            "links": obj.get("links")
        })
        return _obj


